<?php

/* function HfdGetDomHcs(&$paramTable, $hfdRoot) */
function HfdGetDomHcs($hfdRoot) 
{
  $hcsPath=$hfdRoot.".hcs";
  if (file_exists($hcsPath))
    {
      $hcsFile = file($hcsPath); 
      $hcsDom =  new DomDocument();
      $hcsDom->loadXML("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>".$hcsFile[0]); 
      return $hcsDom;
    }
  else return false;
}

function HfdHcsNextDigitFromProfile($profile,$iChar)
{
   $pos = strpos($profile, $iChar);
   if ($pos === false) return false;
   if ($pos>=(strlen($profile)-1)) return false;
   return $profile[$pos+1];
}

function HfdHcsPreviousDigitFromProfile($profile,$iChar)
{
   $pos = strpos($profile, $iChar);
   if ($pos === false) return false;
   if ($pos==0) return false;
   return $profile[$pos-1];
}

function HfdHcsFirstInKeyPart($dirFileKey)
{
  $str="";
  foreach($dirFileKey->childNodes as $digit)
    {
      $str=$str.$digit->nodeValue[0];
    }
  return $str;
}

function HfdHcsNextDigitInKeyPart($digitNode, $i, $str)
{
  $cIn=$str[$i];
  $profileStr=$digitNode->nodeValue;
  if (($cOut=HfdHcsNextDigitFromProfile($profileStr,$cIn)))
    {
      $str[$i]=$cOut;
      return $str;
    }
  else
    {
      if ($i>0) 
	{
	  $str[$i]=$profileStr[0];
	  return HfdHcsNextDigitInKeyPart($digitNode->previousSibling, $i-1, $str);
	}
      else return NULL;
    }
}

function HfdHcsNextInKeyPart($dirFileKey, $k)
{
  $str=$k;
  $i=strlen($k)-1;
  $digitNode=$dirFileKey->lastChild;
  return HfdHcsNextDigitInKeyPart($digitNode, $i, $str);
}

function HfdHcsNextDigitInKey($digitNode, $i, $str)
{
  $cIn=$str[$i];
  $profileStr=$digitNode->nodeValue;
  if (($cOut=HfdHcsNextDigitFromProfile($profileStr,$cIn)))
    {
      $str[$i]=$cOut;
      return $str;
    }
  if ($i==0) return NULL;
  $str[$i]=$profileStr[0];
  $ps=$digitNode->previousSibling;
  if ($ps) return HfdHcsNextDigitInKey($ps, $i-1, $str);
  $ps=$digitNode->parentNode->previousSibling->lastChild;
  return HfdHcsNextDigitInKey($ps, $i-1, $str);
}


function HfdHcsPreviousDigitInKey($digitNode, $i, $str)
{
  $cIn=$str[$i];
  $profileStr=$digitNode->nodeValue;
  $cOut=HfdHcsPreviousDigitFromProfile($profileStr,$cIn);
  if ($cOut==='0')
    {
      $str[$i]=$cOut;
      return $str;
    }
  if ($cOut)
    {
      $str[$i]=$cOut;
      return $str;
    }
  if ($i==0) return NULL;
  $str[$i]=$profileStr[strlen($profileStr)-1];
  $ps=$digitNode->previousSibling;
  if ($ps) return HfdHcsPreviousDigitInKey($ps, $i-1, $str);
  $ps=$digitNode->parentNode->previousSibling->lastChild;
  return HfdHcsPreviousDigitInKey($ps, $i-1, $str);
}





function HfdHcsNextHfdKey($hcs, $key)
{
  $lastKey=SxmlNodeGetFirstChildByTagName($hcs, "lastkey");
  if (strcmp($key, $lastKey->nodeValue)>=0) return NULL;
  $str=$key;
  $i=strlen($key)-1;
  $digitNode=SxmlNodeGetFirstChildByTagName($hcs,"struct")->lastChild->lastChild;
  return HfdHcsNextDigitInKey($digitNode, $i, $str);
}


function HfdHcsPreviousHfdKey($hcs, $key)
{
  $lastKey=SxmlNodeGetFirstChildByTagName($hcs, "lastkey");
  $struct=SxmlNodeGetFirstChildByTagName($hcs, "struct");
  $firstKey="";
  foreach ($struct->childNodes as $dirOrFile)
    {
      foreach ($dirOrFile->childNodes as $digitNode)
	{
	  $digit=$digitNode->nodeValue;
	  $firstKey=$firstKey.$digit[0];
	}
    }

  if (strcmp($key, $firstKey)<=0) return NULL;
  $str=$key;
  $i=strlen($key)-1;
  $digitNode=$struct->lastChild->lastChild;
  return HfdHcsPreviousDigitInKey($digitNode, $i, $str);
}


function HfdGetXmlDomFromNumKey(&$paramTable, $hfdRoot,  $hfdKey)
        {
          $paramTable["#errCode"]=0;
          $paramTable["#errText"]="OK";
	  $part1=substr($hfdKey,0,2);
	  $part2=substr($hfdKey,2,2);
	  
	  $racine=$hfdRoot.".hfd/".$part1.".dd/".$part2.".df";
	  if (file_exists($racine))
	    {
	      $fichier=file($racine); 
	      $existe=false;
	      for( $i = 0 ; $i < count($fichier) ; $i++ )
		{
		  if (strcmp(substr($fichier[$i],0,6),$hfdKey)==0)
		    {
		      $noticeText=substr($fichier[$i],7);
		      $existe=true;     
		      break;
		    }
		}
	      if ($existe==false)
		{
		  $paramTable ["#errCode"]=1;
		  $paramTable ["#errText"]="hfd key not founded";
		  return false;
		}
	    }
	  else 
	    {
	      $paramTable ["#errCode"]=2;
	      $paramTable ["#errText"]="hfd: file".$racine."not founded";
	      return false;
	    }
	  $domNotice = new DomDocument();
	  /* echo $noticeText; echo "\n"; */
	  $domNotice->loadXML("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>".$noticeText); 
	  if (!$domNotice)$paramTable ["#errText"]="parsing error";
	  return $domNotice;
        }

function HfdRepositoryGetXmlDomFromNumKey(&$paramTable, $hfdRoot,  $hfdKey)
        {
	  $part1=substr($hfdKey,0,2);
	  $part2=substr($hfdKey,2,2);
	  $part3=substr($hfdKey,4,2);
	  $racine=$hfdRoot.".hfd/".$part1.".dd/".$part2.".dd/".$part3.".df";
	  if (file_exists($racine))
	    {
	      $fichier=file($racine); 
	      $noticeText=substr($fichier[0],7);
	      $domNotice = new DomDocument();
	      $domNotice->loadXML("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>".$noticeText); 
	      if (!$domNotice)$paramTable ["#errText"]="parsing error";
	      return $domNotice;
	    }
	  return NULL;
	}

function HfdGetHFdKeyFromHid($hidTab, $key)
{
  $i=0;
  while ($i < count($hidTab))
    {
#      $hidTabKey=substr($hidTab[$i],0,mb_strpos($hidTab[$i], "\t"));
      $hidTabKey=substr($hidTab[$i],0,strpos($hidTab[$i], "\t"));
      if(strcmp($hidTabKey,$key)>0)
	/* if($hidTabKey > $key) */
        {
          if ($i==0) return false;
#          return substr($hidTab[$i-1],mb_strpos($hidTab[$i-1], "\t")+1,6);
          return substr($hidTab[$i-1], strpos($hidTab[$i-1], "\t")+1,6);
        }
      else $i++;
    }
  if ($i==0) return NULL;
#  return substr($hidTab[$i-1],mb_strpos($hidTab[$i-1], "\t")+1,6);
  return substr($hidTab[$i-1], strpos($hidTab[$i-1], "\t")+1,6);
}


function HfdGetXmlDomFromIndexKey(&$paramTable,$indexPath, $key)
{
  $indexHid= $indexPath.".hid";
  
  if (file_exists($indexHid))
    {
      $hidTab=file($indexHid);
      if(!($hfdNum=HfdGetHFdKeyFromHid($hidTab, $key))) return false;
      $indexHfdPath=$indexPath.".hfd/". substr($hfdNum,0,2).".dd/". substr($hfdNum,2,2).".df";
      if(file_exists($indexHfdPath))
        {
          $hfdSet=file($indexHfdPath);
          $i=0;
          while ($i < count($hfdSet))
            {
              $indexRecDocument=new DomDocument();
#	      $posTab=mb_strpos($hfdSet[$i], "\t");
	      $posTab=strpos($hfdSet[$i], "\t");
              $indexRecDocument->loadXML("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>".substr($hfdSet[$i], $posTab ));
	      $HfdKey=substr($hfdSet[$i],0, $posTab);
	      $paramTable ["#HfdKey"]=$HfdKey;
              $indexRecKey=$indexRecDocument->documentElement->firstChild->nodeValue;
              if ($indexRecKey==$key) return  $indexRecDocument;
	      if (strcmp($indexRecKey,$key)>0) 
		{
		  $paramTable ["#HfdIndexKey"]=$indexRecKey;
		  return false; 
		}
              $i++;
            }
        }
    }
  else echo "**** Hid ".$indexHid. " not founded ****\n";
  return false;
}


function HfdGetArrayFromIndexKey(&$paramTable,$indexPath, $key)
{
  $indexDom= HfdGetXmlDomFromIndexKey($paramTable,$indexPath, $key);
  if (!$indexDom) echo $paramTable["#errText"];
  $liste=SxmlNodeGetFirstChildByTagName($indexDom->documentElement,"l");
  $array=array();
  foreach ($liste->childNodes as $eNode) 
    $array[]=$eNode->nodeValue;
  return $array;
}

?>
